addHook("LinedefExecute", function(line, mobj, sec)
	if not (mobj.player and mobj.player.valid) then return end
	if mapheaderinfo[gamemap].dnfsecret then return end -- if the server doesnt allow finishing via the secret
	mobj.player.laps = $ + 1 // good job
	mobj.player.starpostnum = 0
	mobj.player.kartstuff[k_lapanimation] = 80
	if G_BattleGametype() then -- nope
		P_KillMobj(mobj)
	end
	COM_BufInsertText(mobj.player, "cecho good job")
end, "MAPHQSCR01")

addHook("MusicChange", function(oldmusic, newmusic, flags, looping)
	if not G_BattleGametype() then return end
	if not mapheaderinfo[gamemap].bttlmus then return end
	local muslump = mapheaderinfo[gamemap].bttlmus
	if oldmusic == muslump and newmusic ~= muslump then
		return muslump
	end
	
	if newmusic == mapmusname then
		return muslump -- You're GONNA hear this fucking starting music.
	end
end)

local function offroadlmao()
	if not mapheaderinfo[gamemap].offroadlmao then return end
	for p in players.iterate do
		if not (p.mo and p.mo.valid) then continue end
		if p.speed > 20 and P_IsObjectOnGround(p.mo) then
			K_SpawnWipeoutTrail(p.mo, true)
			if leveltime % 6 == 0 then
				S_StartSound(p.mo, sfx_cdfm70)
			end
		end
	end
end

addHook("PostThinkFrame", offroadlmao)

-- taken from LUA_OBSK.lua
local function tableparse(x)
	local y = {}
	local i = 0
	for word in x:gmatch('[^,%s]+') do
		y[i+1] = word 
		i = $+1
	end	
	return y
end

local function resetshit()
	server.positions = nil
end

local starttime = 6*TICRATE

// ecnore pos lmao
local function stairs()
	if not mapheaderinfo[gamemap].encorecoords then return end
	if not encoremode then return end
	if not server.positions then
		server.positions = tableparse(mapheaderinfo[gamemap].encorecoords)
	end
	for p in players.iterate do
		if not (p.mo and p.mo.valid) then continue end
		if leveltime < starttime or p.playerstate == PST_REBORN then 
			P_SetOrigin(p.mo, server.positions[1]*FRACUNIT, server.positions[2]*FRACUNIT, p.mo.z)
			if server.positions[3] then p.mo.angle = FixedAngle(server.positions[3]*FRACUNIT) end
		end
	end
end

addHook("MapChange", resetshit)
addHook("ThinkFrame", stairs)

local function endlevellmao(line, playerMo, sector)
	if not (playerMo and playerMo.valid and playerMo.player and playerMo.player.valid) then return end
	P_DoPlayerExit(playerMo.player)
end

addHook("LinedefExecute", endlevellmao, "SGATEWAYEXIT")